#### read_at (6 of 8 overloads)

Attempt to read a certain amount of data at the specified offset before returning.

    template<
        typename SyncRandomAccessReadDevice,
        typename Allocator>
    std::size_t read_at(
        SyncRandomAccessReadDevice & d,
        uint64_t offset,
        basic_streambuf< Allocator > & b,
        asio::error_code & ec);

This function is used to read a certain number of bytes of data from a random access device at the specified offset. The call will block until one of the following conditions is true:

- An error occurred.

This operation is implemented in terms of zero or more calls to the device's read_some_at function.

###### Parameters

d

  The device from which the data is to be read. The type must support the SyncRandomAccessReadDevice concept.

offset

  The offset at which the data will be read.

b

  The `basic_streambuf` object into which the data will be read.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes transferred.

###### Remarks

This overload is equivalent to calling:

    asio::read_at(
       d, 42, b,
       asio::transfer_all(), ec);